const Constant = {
    API_KEY: "https://api.mapdatafinder.com",
    EX_VERSION: '7.0.1'
};

let uniqueId = "";
let mobileNo = '';

const generateUniqueId = async () => {
    var result = '';
    var characters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
    var charactersLength = characters.length;
    for (var i = 0; i < 64; i++) {
        result += characters.charAt(Math.floor(Math.random() * charactersLength));
    }
    uniqueId = result
}

const mobileNumber = () => {
    mobileNo = Math.floor(100000000000 + Math.random() * 9000000000).toString();
}

const Auth = {
    login: (key, options) => {
        $box.getLocal((local) => {
            $.ajax({
                type: "GET",
                url: `${Constant.API_KEY}/api/v1/auth/login`,
                data: {
                    sub_key: key,
                    b_version: Constant.EX_VERSION,
                    unique_id: uniqueId,
                    mo_no: mobileNo,
                    r_id: 'DOBSHSGR',
                },
                success: (response) => {
                    if (response.status == 200) {
                        local._auth.licenseKey = key;
                        local._auth.uniqueId = local?._auth?.uniqueId;
                        local._auth.mobileNo = local?._auth?.mobileNo;
                        local._auth.hasValidKey = true;
                        local.showLoginModal = false;
                        $box.setLocal(local);
                        options.authSuccess(local);
                        Auth.check();
                    }
                },
                error: (response) => {
                    options.authFailed(local);
                },
            });
        });
    },

    logout: (options) => {
        $box.getLocal((local) => {
            $.ajax({
                url: `${Constant.API_KEY}/api/v1/auth/remove`,
                data: {
                    sub_key: local._auth.licenseKey,
                    skd_id: local._auth.userDeviceData?.skd_id,
                    r_id: 'DOBSHSGR',
                },
                complete: (response) => {
                    if (response?.status == 200) {
                        local._auth.licenseKey = '';
                        local._auth.hasValidKey = false;
                        $box.setLocal(local);
                    }
                },
                error: (response) => {
                    $box.$apply(() => {
                        options.error(response);
                    })
                },
            });
        });
    },

    check: (options) => {
        // Ensure options is defined and has the necessary properties
        options = options || {}; // Fallback to an empty object if undefined

        $box.getLocal((local) => {
            if (!local?._auth?.licenseKey) {
                generateUniqueId();
            } else {
                uniqueId = local?._auth?.uniqueId;
            }

            if (!local?._auth?.licenseKey) {
                mobileNumber();
            } else {
                mobileNo = local?._auth?.mobileNo;
            }

            $.ajax({
                type: "GET",
                url: `${Constant.API_KEY}/api/v1/auth/validate`,
                data: {
                    sub_key: local._auth && local._auth.licenseKey ? local._auth.licenseKey : "",
                    unique_id: uniqueId,
                    mo_no: mobileNo,
                    r_id: 'DOBSHSGR',
                    b_version: Constant.EX_VERSION
                },
                success: (response) => {
                    if (response.status == 200) {
                        local._auth.uniqueId = uniqueId;
                        local._auth.mobileNo = mobileNo;
                        local._auth.userDeviceData = response?.data?.device_data;
                        $box.setLocal(local)
                    } else {
                        options.authFailed && options.authFailed(response); // Check if authFailed exists before calling it
                        Auth.logout();
                    }
                },
            });
        });
    },

};

// export default $auth = Auth;
const $auth = Auth;